/* ftime.c */

/* it was a part of blarslib */
/* it was slightly modified by k.furukawa for libs2 */

/* #include <sys/types.h> */
#include "os9systypes.h"
/* #include <sys/timeb.h> */
#include "os9systimeb.h"
#include <stdio.h>

char *getenv(), *strchr();

#define JD70 	2440587		/* julian date of jan 1, 1970 */

void ftime(tp)
register struct timeb *tp;
{
    int time, date;
    struct {
    	short tps;
	short cur;
    } tick;
    short day;
    register char *tz, *p;

    _sysdate(3, &time, &date, &day, &tick);
    tp->time = (date - JD70) * (60 * 60 * 24) + time;
    tp->millitm = (tick.cur * 1000) / tick.tps;
    if((tz = getenv("TZ")) != NULL) {
        tp->timezone = 0;
	tp->dstflag = 1;
	if(strlen(tz) >= 3) {
        switch(tz[0]) {
	    case 'G':	/* GMT */
	    	tp->dstflag = 0;
	        break;
	    case 'U':	/* UCT */
	        tp->dstflag = 0;
	        break;
	    case 'P':	/* PST/PDT */
	        if(tz[1] == 'S') tp->timezone = -7 * 60;
		else if(tz[1] == 'D') tp->timezone = -8 * 60;
		break;
	    case 'M':	/* MST/MDT */
		if(tz[1] == 'S') tp->timezone = -6 * 60;
		else if(tz[1] == 'D') tp->timezone = -7 * 60;
		break;
	    case 'C':	/* CST/CDT/CET */
	    	switch(tz[1]) {
		    case 'S':
			tp->timezone = -5 * 60;
			break;
		    case 'D':
		    	tp->timezone = -6 * 60;
			break;
		    case 'E':
		    	tp->timezone = 2 * 60; /* ? */
			break;
		}
		break;
	    case 'E':	/* EST/EDT/EET */
	    	switch(tz[1]) {
		    case 'S':
		    	tp->timezone = -4 * 60;
			break;
		    case 'D':
		    	tp->timezone = -5 * 60;
			break;
		    case 'E':
		    	tp->timezone = 3 * 60; /* ? */
			break;
		}
		break;
	    case 'Y':	/* YST */
	    	tp->timezone = -8 * 60; /* ? */
		break;
	    case 'A':	/* AST */
	    	tp->timezone = -9 * 60; /* ? */
		tp->dstflag = 0;
		break;
	    case 'W':	/* WET */
	    	tp->timezone = 1 * 60; /* ? */
		break;
	    default:
	    	break;
	}
	if(strlen(tz) >= 5) {
	    tp->timezone += atol(&tz[4]);
	    p = strchr(tz, ":");
	    if(p) {
	    	p++;
		switch(*p) {
		    case 'n': case 'N':
		    	tp->dstflag = 0;
		    	break;
		    default:
		    	tp->dstflag = 1;
			break;
		}
	    }
	}
	}
	tp->time -= tp->timezone * 60;
    } else {
    	tp->timezone = 0;
	tp->dstflag = 0;
    }
}
